/* kindly provided by Andreas Borchert */
#include <termios.h>
#include <stdio.h>

/* liest ein Zeichen von stdin ein, ohne */
/* auf das Ende der Zeile zu warten und */
/* ohne das Zeichen auszugeben */
int getkey() {
    struct termios origstate, changedstate;

    /* alten Terminalzustand speichern (von stdin = id 0) */
    if (tcgetattr(0, &origstate) != 0)
	printf("tcgetattr failed");
    changedstate = origstate;

    /* neuen Terminalzustand setzen (von stdin = id 0) */
    changedstate.c_lflag &= ~ICANON; /* disable canonical input */
    changedstate.c_lflag &= ~ECHO;	 /* disable output */
    changedstate.c_cc[VMIN] = 1;	 /* min = 1 */
    changedstate.c_cc[VTIME] = 1;	 /* time = 1/10 sec */
    if (tcsetattr(0, TCSANOW, &changedstate) != 0)
	printf("tcsetattr failed");

    /* Zeichen einlesen */
    //int ch = cin.get();
	int ch = getchar();

    /* alten Terminalzustand wiederherstellen (von stdin = id 0) */
    if (tcsetattr(0, TCSANOW, &origstate) != 0)
	printf("tcsetattr failed");

    return ch;
}

int main() {
	int ch;
	printf("Type something and finish it with '.':\n");
	while ((ch = getkey()) != EOF && ch != '.')
	    printf("Got %c\n",(char) ch);
	printf("Thanks!\n");
	return 0;
}
